## buildbot 4.0.2

=== Makefile ===
# Enable more strict mode for shell
.SHELLFLAGS := -eu -c

# developer utilities
DOCKERBUILD := docker build --build-arg http_proxy=$$http_proxy --build-arg https_proxy=$$https_proxy
ROOT_DIR := $(shell dirname $(realpath $(firstword $(MAKEFILE_LIST))))

.PHONY: docs pylint ruff virtualenv

ifeq ($(OS),Windows_NT)
  VENV_BIN_DIR := Scripts
  VENV_PY_VERSION ?= python
  VENV_CREATE := python -m venv
else
  VENV_BIN_DIR := bin
  VENV_PY_VERSION ?= python3
  VENV_CREATE := virtualenv -p $(VENV_PY_VERSION)
endif

VENV_NAME := .venv$(VENV_PY_VERSION)
PIP ?= $(ROOT_DIR)/$(VENV_NAME)/$(VENV_BIN_DIR)/pip
VENV_PYTHON ?= $(ROOT_DIR)/$(VENV_NAME)/$(VENV_BIN_DIR)/python
YARN := $(shell which yarnpkg || which yarn)

WWW_PKGS := www/base www/react-base www/console_view www/react-console_view www/grid_view www/react-grid_view www/waterfall_view www/react-waterfall_view www/wsgi_dashboards www/react-wsgi_dashboards www/badges
WWW_EX_PKGS := www/nestedexample www/codeparameter
WWW_DEP_PKGS := www/plugin_support www/data-module www/ui
ALL_PKGS := master worker pkg $(WWW_PKGS)

WWW_PKGS_FOR_UNIT_TESTS := $(filter-out www/badges www/plugin_support www/ui www/grid_view www/react-grid_view www/wsgi_dashboards www/react-wsgi_dashboards, $(WWW_DEP_PKGS) $(WWW_PKGS))

ALL_PKGS_TARGETS := $(addsuffix _pkg,$(ALL_PKGS))
.PHONY: $(ALL_PKGS_TARGETS)

# build rst documentation
docs:
	$(MAKE) -C master/docs dev
	@echo "You can now open master/docs/_build/html/index.html"

docs-towncrier:
	# Check that master/docs/relnotes/index.rst is not already generated (so it's in the staging area).
	# If docs-release and docs-release-spelling are called one after the other, then towncrier will report duplicate release notes.
	if ! git diff --name-only --cached | grep -q "master/docs/relnotes/index.rst"; then \
	if command -v towncrier >/dev/null 2>&1 ;\
	then \
	towncrier --draft | grep  'No significant changes.' || yes n | towncrier ;\
	fi \
	fi

docs-spelling:
	$(MAKE) -C master/docs SPHINXOPTS=-W spelling

docs-linkcheck:
	$(MAKE) -C master/docs SPHINXOPTS=-q linkcheck

docs-release: docs-towncrier
	$(MAKE) -C master/docs

docs-release-spelling: docs-towncrier
	$(MAKE) -C master/docs SPHINXOPTS=-W spelling

# pylint the whole sourcecode (validate.sh will do that as well, but only process the modified files)
pylint:
	$(MAKE) -C master pylint; master_res=$$?; \
	$(MAKE) -C worker pylint; worker_res=$$?; \
	if [ $$master_res != 0 ] || [ $$worker_res != 0 ]; then exit 1; fi

frontend_deps: $(VENV_NAME)
	$(PIP) install build wheel -r requirements-ci.txt
	for i in $(WWW_DEP_PKGS); \
		do (cd $$i; $(YARN) install --pure-lockfile; $(YARN) run build); done

frontend_tests: frontend_deps
	for i in $(WWW_PKGS); \
		do (cd $$i; $(YARN) install --pure-lockfile); done
	for i in $(WWW_PKGS_FOR_UNIT_TESTS); \
		do (cd $$i; $(YARN) run build-dev || exit 1; $(YARN) run test || exit 1) || exit 1; done

# rebuild front-end from source
frontend: frontend_deps
	for i in pkg $(WWW_PKGS); do $(PIP) install -e $$i || exit 1; done

# build frontend wheels for installation elsewhere
frontend_wheels: frontend_deps
	for i in pkg $(WWW_PKGS); \
		do (cd $$i; $(VENV_PYTHON) -m build --no-isolation --wheel || exit 1) || exit 1; done

# do installation tests. Test front-end can build and install for all install methods
frontend_install_tests: frontend_deps
	trial pkg/test_buildbot_pkg.py pkg/test_buildbot_pkg_old.py

# upgrade FE dependencies
frontend_yarn_upgrade:
	for i in $(WWW_PKGS) $(WWW_EX_PKGS) $(WWW_DEP_PKGS); \
		do (cd $$i; echo $$i; rm -rf yarn.lock; $(YARN) install || echo $$i failed); done

# install git hooks for validating patches at commit time
hooks:
	cp common/hooks/* `git rev-parse --git-dir`/hooks
rmpyc:
	find master worker \( -name '*.pyc' -o -name '*.pyo' \) -exec rm -v {} \;

ruff:
	ruff --fix .

docker: docker-buildbot-worker docker-buildbot-master
	echo done
docker-buildbot-worker:
	$(DOCKERBUILD) -t buildbot/buildbot-worker:master worker
docker-buildbot-master:
	$(DOCKERBUILD) -t buildbot/buildbot-master:master master

$(VENV_NAME):
	$(VENV_CREATE) $(VENV_NAME)
	$(VENV_PYTHON) -m pip install --upgrade pip
	$(PIP) install -U setuptools wheel

# helper for virtualenv creation
virtualenv: $(VENV_NAME)   # usage: make virtualenv VENV_PY_VERSION=python3.4
	$(PIP) install -r requirements-ci.txt \
		-r requirements-ciworker.txt \
		-r requirements-cidocs.txt \
		packaging towncrier
	@echo now you can type following command  to activate your virtualenv
	@echo . $(VENV_NAME)/$(VENV_BIN_DIR)/activate

TRIALOPTS?=buildbot

.PHONY: trial
trial: virtualenv
	. $(VENV_NAME)/$(VENV_BIN_DIR)/activate && trial $(TRIALOPTS)

release_notes: $(VENV_NAME)
	test ! -z "$(VERSION)"  #  usage: make release_notes VERSION=0.9.2
	towncrier build --yes  --version $(VERSION) --date `date -u  +%F`
	git commit -m "Release notes for $(VERSION)"

$(ALL_PKGS_TARGETS): cleanup_for_tarballs frontend_deps
	. $(VENV_NAME)/$(VENV_BIN_DIR)/activate && ./common/maketarball.sh $(patsubst %_pkg,%,$@)

cleanup_for_tarballs:
	find master pkg worker www -name VERSION -exec rm {} \;
	rm -rf dist
	mkdir dist
.PHONY: cleanup_for_tarballs
tarballs: $(ALL_PKGS_TARGETS)
.PHONY: tarballs

# helper for release creation
release: virtualenv
	test ! -z "$(VERSION)"  #  usage: make release VERSION=0.9.2
	test -d "../bbdocs/.git"  #  make release should be done with bbdocs populated at the same level as buildbot dir
	GPG_TTY=`tty` git tag -a -sf v$(VERSION) -m "TAG $(VERSION)"
	git push buildbot "v$(VERSION)"  # tarballs are made by circleci.yml, and create a github release
	export VERSION=$(VERSION) ; . $(VENV_NAME)/$(VENV_BIN_DIR)/activate && make docs-release
	rm -rf ../bbdocs/docs/$(VERSION)  # in case of re-run
	cp -r master/docs/_build/html ../bbdocs/docs/$(VERSION)
	cd ../bbdocs && git pull
	. $(VENV_NAME)/$(VENV_BIN_DIR)/activate && cd ../bbdocs && make && git add docs && git commit -m $(VERSION) && git push
	@echo When tarballs have been generated by circleci:
	@echo make finishrelease

finishrelease:
	rm -rf dist
	python3 ./common/download_release.py
	rm -rf ./dist/v*
	twine upload dist/*

pyinstaller: virtualenv
	$(PIP) install pyinstaller
	$(VENV_NAME)/$(VENV_BIN_DIR)/pyinstaller pyinstaller/buildbot-worker.spec

=== master/Makefile ===
# developer utilities
pylint:
	pylint -j4 --rcfile=../common/pylintrc buildbot docs/*.py setup.py
	@test ! -f fail

tutorial:
	cd docs/tutorial; $(MAKE) html

rmpyc:
	make -C .. rmpyc

=== worker/Makefile ===
# developer utilities
pylint:
	pylint -j4 --rcfile=../common/pylintrc_worker --disable=super-with-arguments,raise-missing-from buildbot_worker setup.py

=== debian/changelog ===
buildbot (4.0.2-1) unstable; urgency=medium

  * Team upload.

  [ Alexandre Detiste ]
  * replace transitional bzr by brz
  * Standards-Version: 4.7.0 (routine-update)
  * New upstream release

  [ Colin Watson ]
  * Cherry-pick upstream patches for compatibility with SQLAlchemy 2.0 and
    Twisted 24.7.0 (closes: #1073001).
  * Use python3-sphinx-jinja now that it's in Debian.
  * Drop buildbot-slave transitional package (closes: #1032636).
  * Drop python3-buildbot transitional package (closes: #1032637).
  * Drop python3-buildbot-worker transitional package (closes: #1032639).
  * Drop python3-buildbot-doc transitional package (closes: #1032646).

 -- Colin Watson <cjwatson@debian.org>  Sun, 08 Sep 2024 13:54:41 +0100

=== debian/control ===
Source: buildbot
Section: devel
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Robin Jarry <robin@jarry.cc>
Standards-Version: 4.7.0
Build-Depends:
 debhelper-compat (= 13),
 dh-python (>= 3.20180313~),
 bash-completion,
 po-debconf,
 git,
 python3 (>= 3.5),
 python3-setuptools (>= 8.0),
 python3-alembic (>= 1.6.0),
 python3-autobahn (>= 0.16.0),
 python3-croniter,
 python3-dateutil (>= 1.5),
 python3-idna,
 python3-jinja2 (>= 2.1),
 python3-jwt,
 python3-openssl,
 python3-parameterized,
 python3-pkg-resources (>= 8.0),
 python3-psutil,
 python3-service-identity,
 python3-sqlalchemy (>= 1.4.0),
 python3-twisted (>= 17.9.0),
 python3-txaio (>= 2.2.2),
 python3-zope.interface (>= 4.1.1),
 python3-treq,
 python3-txrequests,
 python3-unidiff (>= 0.6.0),
 python3-yaml,
 python3-sphinx,
 python3-sphinx-jinja,
 python3-sphinx-rtd-theme,
 python3-docutils,
 sphinx-doc,
 sphinx-common,
 scdoc,
Homepage: https://buildbot.net
Vcs-Git: https://salsa.debian.org/python-team/packages/buildbot.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/buildbot
Rules-Requires-Root: no

Package: buildbot
Architecture: all
Depends:
 ${misc:Depends},
 ${python3:Depends},
 python3-alembic (>= 1.6.0),
 python3-autobahn (>= 0.16.0),
 python3-dateutil (>= 1.5),
 python3-idna,
 python3-jinja2 (>= 2.1),
 python3-jwt,
 python3-openssl,
 python3-pkg-resources (>= 8.0),
 python3-service-identity,
 python3-sqlalchemy (>= 1.4.0),
 python3-twisted (>= 17.9.0),
 python3-txaio (>= 2.2.2),
 python3-txrequests,
 python3-unidiff (>= 0.6.0),
 python3-zope.interface (>= 4.1.1),
 passwd,
Recommends:
 buildbot-worker,
 bash-completion,
Suggests:
 buildbot-doc,
 python3-lz4,
 python3-psycopg2 | python3-mysqldb,
Description: System to automate the compile/test cycle (server)
 The BuildBot is a system to automate the compile/test cycle required
 by most software projects to validate code changes. By automatically
 rebuilding and testing the tree each time something has changed,
 build problems are pinpointed quickly, before other developers are
 inconvenienced by the failure. The guilty developer can be identified
 and harassed without human intervention.
 .
 By running the builds on a variety of platforms, developers who do
 not have the facilities to test their changes everywhere before
 checkin will at least know shortly afterwards whether they have
 broken the build or not. Warning counts, lint checks, image size,
 compile time, and other build parameters can be tracked over time,
 are more visible, and are therefore easier to improve.
 .
 This package contains the master server.

Package: buildbot-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Breaks:
 buildbot (<< 1.0),
Replaces:
 buildbot (<< 1.0),
Description: System to automate the compile/test cycle (documentation)
 The BuildBot is a system to automate the compile/test cycle required
 by most software projects to validate code changes. By automatically
 rebuilding and testing the tree each time something has changed,
 build problems are pinpointed quickly, before other developers are
 inconvenienced by the failure. The guilty developer can be identified
 and harassed without human intervention.
 .
 By running the builds on a variety of platforms, developers who do
 not have the facilities to test their changes everywhere before
 checkin will at least know shortly afterwards whether they have
 broken the build or not. Warning counts, lint checks, image size,
 compile time, and other build parameters can be tracked over time,
 are more visible, and are therefore easier to improve.
 .
 This package contains the HTML documentation for both the master
 and worker.

Package: buildbot-worker
Architecture: all
Depends:
 ${misc:Depends},
 ${python3:Depends},
 python3-twisted (>= 17.9.0),
 passwd,
Recommends:
 brz | subversion | cvs | mercurial | darcs | git,
Description: System to automate the compile/test cycle (worker agent)
 The BuildBot is a system to automate the compile/test cycle required
 by most software projects to validate code changes. By automatically
 rebuilding and testing the tree each time something has changed,
 build problems are pinpointed quickly, before other developers are
 inconvenienced by the failure. The guilty developer can be identified
 and harassed without human intervention.
 .
 By running the builds on a variety of platforms, developers who do
 not have the facilities to test their changes everywhere before
 checkin will at least know shortly afterwards whether they have
 broken the build or not. Warning counts, lint checks, image size,
 compile time, and other build parameters can be tracked over time,
 are more visible, and are therefore easier to improve.
 .
 This package contains the worker, which performs the actual builds.
 It is recommended to run the worker on behalf of a non-privileged user.

## buildbot 4.1.0

=== master/docker-example/pypy/master/requirements.txt ===
buildbot[bundle]
psycopg2cffi-compat

=== debian/changelog ===
buildbot (4.1.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release:
    - rest: remove usage of deprecated cgi module (closes: #1084649).
  * Fix CommandToString.test_list_with_objects (see
    https://github.com/buildbot/buildbot/pull/8137).

 -- Colin Watson <cjwatson@debian.org>  Mon, 21 Oct 2024 22:09:33 +0100

buildbot (4.0.3-2) unstable; urgency=medium

  * Team upload.
  * Remove unused (build-)dependencies on python3-pkg-resources (closes:
    #1083325).
  * Add Italian debconf translation (thanks, Ceppo; closes: #1081503).

 -- Colin Watson <cjwatson@debian.org>  Fri, 04 Oct 2024 13:16:59 +0100

buildbot (4.0.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Colin Watson <cjwatson@debian.org>  Sun, 29 Sep 2024 18:11:35 +0100

## buildbot 4.2.0

=== debian/changelog ===
buildbot (4.2.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Colin Watson <cjwatson@debian.org>  Sun, 15 Dec 2024 00:00:18 +0000

buildbot (4.1.0-2) unstable; urgency=medium

  * Team upload.
  * process: Remove uses of twisted.python.constants.

 -- Colin Watson <cjwatson@debian.org>  Sun, 08 Dec 2024 15:31:59 +0000

## buildbot 4.2.1

=== Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 DOCKERBUILD := docker build --build-arg http_proxy=$$http_proxy --build-arg https_proxy=$$https_proxy
 ROOT_DIR := $(shell dirname $(realpath $(firstword $(MAKEFILE_LIST))))
 
-.PHONY: docs pylint ruff virtualenv
+.PHONY: docs ruff virtualenv check_for_yarn
 
 ifeq ($(OS),Windows_NT)
   VENV_BIN_DIR := Scripts
@@ -22,12 +22,15 @@
 VENV_PYTHON ?= $(ROOT_DIR)/$(VENV_NAME)/$(VENV_BIN_DIR)/python
 YARN := $(shell which yarnpkg || which yarn)
 
-WWW_PKGS := www/base www/react-base www/console_view www/react-console_view www/grid_view www/react-grid_view www/waterfall_view www/react-waterfall_view www/wsgi_dashboards www/react-wsgi_dashboards www/badges
-WWW_EX_PKGS := www/nestedexample www/codeparameter
+check_for_yarn:
+	@if [ "$(YARN)" = "" ]; then echo "yarnpkg or yarn is not installed" ; exit 1; fi
+
+WWW_PKGS := www/base www/console_view www/grid_view www/waterfall_view www/wsgi_dashboards www/badges
+WWW_EX_PKGS := www/nestedexample
 WWW_DEP_PKGS := www/plugin_support www/data-module www/ui
 ALL_PKGS := master worker pkg $(WWW_PKGS)
 
-WWW_PKGS_FOR_UNIT_TESTS := $(filter-out www/badges www/plugin_support www/ui www/grid_view www/react-grid_view www/wsgi_dashboards www/react-wsgi_dashboards, $(WWW_DEP_PKGS) $(WWW_PKGS))
+WWW_PKGS_FOR_UNIT_TESTS := $(filter-out www/badges www/plugin_support www/grid_view www/wsgi_dashboards, $(WWW_DEP_PKGS) $(WWW_PKGS))
 
 ALL_PKGS_TARGETS := $(addsuffix _pkg,$(ALL_PKGS))
 .PHONY: $(ALL_PKGS_TARGETS)
@@ -59,18 +62,12 @@
 docs-release-spelling: docs-towncrier
 	$(MAKE) -C master/docs SPHINXOPTS=-W spelling
 
-# pylint the whole sourcecode (validate.sh will do that as well, but only process the modified files)
-pylint:
-	$(MAKE) -C master pylint; master_res=$$?; \
-	$(MAKE) -C worker pylint; worker_res=$$?; \
-	if [ $$master_res != 0 ] || [ $$worker_res != 0 ]; then exit 1; fi
-
-frontend_deps: $(VENV_NAME)
+frontend_deps: $(VENV_NAME) check_for_yarn
 	$(PIP) install build wheel -r requirements-ci.txt
 	for i in $(WWW_DEP_PKGS); \
 		do (cd $$i; $(YARN) install --pure-lockfile; $(YARN) run build); done
 
-frontend_tests: frontend_deps
+frontend_tests: frontend_deps check_for_yarn
 	for i in $(WWW_PKGS); \
 		do (cd $$i; $(YARN) install --pure-lockfile); done
 	for i in $(WWW_PKGS_FOR_UNIT_TESTS); \
@@ -87,10 +84,10 @@
 
 # do installation tests. Test front-end can build and install for all install methods
 frontend_install_tests: frontend_deps
-	trial pkg/test_buildbot_pkg.py pkg/test_buildbot_pkg_old.py
+	trial pkg/test_buildbot_pkg.py
 
 # upgrade FE dependencies
-frontend_yarn_upgrade:
+frontend_yarn_upgrade: check_for_yarn
 	for i in $(WWW_PKGS) $(WWW_EX_PKGS) $(WWW_DEP_PKGS); \
 		do (cd $$i; echo $$i; rm -rf yarn.lock; $(YARN) install || echo $$i failed); done
 
@@ -101,22 +98,23 @@
 	find master worker \( -name '*.pyc' -o -name '*.pyo' \) -exec rm -v {} \;
 
 ruff:
-	ruff --fix .
+	ruff format .
 
 docker: docker-buildbot-worker docker-buildbot-master
 	echo done
 docker-buildbot-worker:
 	$(DOCKERBUILD) -t buildbot/buildbot-worker:master worker
+docker-buildbot-worker-node:
+	$(DOCKERBUILD) -t buildbot/buildbot-worker-node:master master/contrib/docker/pythonnode_worker
 docker-buildbot-master:
 	$(DOCKERBUILD) -t buildbot/buildbot-master:master master
 
 $(VENV_NAME):
 	$(VENV_CREATE) $(VENV_NAME)
-	$(VENV_PYTHON) -m pip install --upgrade pip
-	$(PIP) install -U setuptools wheel
+	$(PIP) install -r requirements-pip.txt
 
 # helper for virtualenv creation
-virtualenv: $(VENV_NAME)   # usage: make virtualenv VENV_PY_VERSION=python3.4
+virtualenv: $(VENV_NAME) check_for_yarn   # usage: make virtualenv VENV_PY_VERSION=python3.8
 	$(PIP) install -r requirements-ci.txt \
 		-r requirements-ciworker.txt \
 		-r requirements-cidocs.txt \

=== debian/changelog ===
buildbot (4.2.1-1) unstable; urgency=medium

  * Team upload.
  * debian/upstream/signing-key.asc: Merge into a single ASCII-armored
    block, to improve interoperability.
  * New upstream release.

 -- Colin Watson <cjwatson@debian.org>  Fri, 17 Jan 2025 14:47:38 +0000

## buildbot 4.3.0

=== Makefile ===
--- 
+++ 
@@ -30,7 +30,7 @@
 WWW_DEP_PKGS := www/plugin_support www/data-module www/ui
 ALL_PKGS := master worker pkg $(WWW_PKGS)
 
-WWW_PKGS_FOR_UNIT_TESTS := $(filter-out www/badges www/plugin_support www/grid_view www/wsgi_dashboards, $(WWW_DEP_PKGS) $(WWW_PKGS))
+WWW_PKGS_FOR_UNIT_TESTS := $(filter-out www/badges www/plugin_support www/wsgi_dashboards, $(WWW_DEP_PKGS) $(WWW_PKGS))
 
 ALL_PKGS_TARGETS := $(addsuffix _pkg,$(ALL_PKGS))
 .PHONY: $(ALL_PKGS_TARGETS)
@@ -100,6 +100,10 @@
 ruff:
 	ruff format .
 
+mypy:
+	(cd ./master && mypy --config-file ../pyproject.toml buildbot)
+	(cd ./worker && mypy --config-file ../pyproject.toml buildbot_worker)
+
 docker: docker-buildbot-worker docker-buildbot-master
 	echo done
 docker-buildbot-worker:

=== master/Makefile ===
# developer utilities
tutorial:
	cd docs/tutorial; $(MAKE) html

rmpyc:
	make -C .. rmpyc

=== master/docs/Makefile ===
all: docs.tgz

dev: clean html

.PHONY: tutorial manual

VERSION := $(shell if [ -n "$$VERSION" ]; then echo $$VERSION; else PYTHONPATH=..:$${PYTHONPATH} python -c 'from buildbot import version; print(version)'; fi)

# sphinx is fastest on Buildbot docs when using around 8 cores. Anything more does not improve the build speed
JOBS := $(shell python -c 'import multiprocessing; print(min(8, multiprocessing.cpu_count()))')

TAR_VERSION := $(shell tar --version)
TAR_TRANSFORM := $(if $(filter bsdtar,$(TAR_VERSION)),-s /^html/$(VERSION)/,--transform s/^html/$(VERSION)/)

docs.tgz: clean html singlehtml
	sed -e 's!href="index.html#!href="#!g' < _build/singlehtml/index.html > _build/html/full.html
	tar -C _build $(TAR_TRANSFORM) -zcf $@ html

# -- Makefile for Sphinx documentation --

# You can set these variables from the command line.
SPHINXOPTS    = -q -W -j $(JOBS)
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
SPHINXENV       = LC_ALL="en_US.UTF-8" LC_CTYPE="en_US.UTF-8"

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html: conf.py
	$(SPHINXENV) $(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml: conf.py
	$(SPHINXENV) $(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml: conf.py
	$(SPHINXENV) $(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle: conf.py
	$(SPHINXENV) $(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json: conf.py
	$(SPHINXENV) $(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp: conf.py
	$(SPHINXENV) $(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp: conf.py
	$(SPHINXENV) $(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/BuildbotTutorial.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/BuildbotTutorial.qhc"

devhelp: conf.py
	$(SPHINXENV) $(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/BuildbotTutorial"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/BuildbotTutorial"
	@echo "# devhelp"

epub: conf.py
	$(SPHINXENV) $(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex: conf.py
	$(SPHINXENV) $(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf: conf.py
	$(SPHINXENV) $(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	make -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text: conf.py
	$(SPHINXENV) $(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man: conf.py
	$(SPHINXENV) $(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

changes: conf.py
	$(SPHINXENV) $(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck: conf.py
	$(SPHINXENV) $(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

spelling: conf.py
	$(SPHINXENV) $(SPHINXBUILD) -b spelling $(ALLSPHINXOPTS) $(BUILDDIR)/spelling
	@echo
	@echo "Spelling check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/spelling/output.txt."

doctest: conf.py
	$(SPHINXENV) $(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== master/docs/_images/Makefile ===

SOURCES = overview_src.svg changes_src.svg workers_src.svg master_src.svg multimaster_src.svg auth_rules_src.svg
SVGS = $(patsubst %_src.svg,%.svg,$(SOURCES))
PNGS = $(patsubst %_src.svg,%.png,$(SOURCES))

.PHONY: images-svg images-png images-eps
all: $(SVGS) $(PNGS) $(EPSS)
images-svg: $(SVGS)
images-png: $(PNGS)

# Source SVG files contains text labels in "Noto Sans" font which may not be
# installed on end user machine. Render these text labels into paths.
# "Noto Sans" font can be downloaded from Google Fonts collection.
%.svg: %_src.svg
	cp $< _tmp.svg
	# Render text as path.
	inkscape _tmp.svg --verb EditSelectAll --verb=ObjectToPath --verb FileSave --verb FileQuit
	# Cleanup SVG to reduce its size.
	scour --enable-comment-stripping --remove-metadata -i _tmp.svg -o $@
	rm -f _tmp.svg
%.png: %.svg
	inkscape -b white --export-png $@ $<
	mogrify -trim +repage $@
clean:
	rm -f $(PNGS) $(SVGS)

=== master/docker-example/pypy/master/requirements.txt ===
buildbot[bundle]==4.1.0
psycopg2cffi-compat==1.1

=== master/docker-example/pypy/worker/requirements.txt ===
buildbot-slave==0.8.14

=== debian/changelog ===
buildbot (4.3.0-1) unstable; urgency=medium

  * Team upload.
  * Re-export debian/upstream/signing-key.asc without subkeys.
  * New upstream release:
    - Partially revert "monkeypatches: Remove unused for_tests argument"
      (closes: #1117640).
  * Fix deprecation warning from alembic >= 1.16.0 (closes: #1117391).

 -- Colin Watson <cjwatson@debian.org>  Sun, 26 Oct 2025 19:59:47 +0000

=== debian/control ===
--- 
+++ 
@@ -16,19 +16,19 @@
  python3-autobahn (>= 0.16.0),
  python3-croniter,
  python3-dateutil (>= 1.5),
+ python3-evalidate,
  python3-idna,
  python3-jinja2 (>= 2.1),
  python3-jwt,
  python3-openssl,
  python3-parameterized,
- python3-pkg-resources (>= 8.0),
  python3-psutil,
  python3-service-identity,
  python3-sqlalchemy (>= 1.4.0),
- python3-twisted (>= 17.9.0),
+ python3-twisted (>= 22.1.0),
  python3-txaio (>= 2.2.2),
  python3-zope.interface (>= 4.1.1),
- python3-treq,
+ python3-treq (>= 20.9),
  python3-txrequests,
  python3-unidiff (>= 0.6.0),
  python3-yaml,
@@ -56,10 +56,10 @@
  python3-jinja2 (>= 2.1),
  python3-jwt,
  python3-openssl,
- python3-pkg-resources (>= 8.0),
  python3-service-identity,
  python3-sqlalchemy (>= 1.4.0),
- python3-twisted (>= 17.9.0),
+ python3-treq (>= 20.9),
+ python3-twisted (>= 22.1.0),
  python3-txaio (>= 2.2.2),
  python3-txrequests,
  python3-unidiff (>= 0.6.0),
@@ -70,6 +70,7 @@
  bash-completion,
 Suggests:
  buildbot-doc,
+ python3-evalidate,
  python3-lz4,
  python3-psycopg2 | python3-mysqldb,
 Description: System to automate the compile/test cycle (server)
@@ -123,7 +124,7 @@
 Depends:
  ${misc:Depends},
  ${python3:Depends},
- python3-twisted (>= 17.9.0),
+ python3-twisted (>= 21.2.0),
  passwd,
 Recommends:
  brz | subversion | cvs | mercurial | darcs | git,

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DH_VERBOSE = 1
export LC_ALL = C.UTF-8
export BUILDBOT_VERSION = $(DEB_VERSION_UPSTREAM)
export PYTHONDONTWRITEBYTECODE = 1

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
MAKEFLAGS += -j$(NUMJOBS)
else
NUMJOBS = 1
endif

override_dh_auto_clean \
override_dh_auto_configure \
override_dh_auto_build:
	$(@:override_%=%) --buildsystem=pybuild --sourcedirectory=master \
		--package=buildbot
	$(@:override_%=%) --buildsystem=pybuild --sourcedirectory=worker \
		--package=buildbot-worker
	@case $@ in \
	override_dh_auto_clean) \
		echo "$(MAKE) -C master/docs clean && $(RM) _trial_temp/"; \
		$(MAKE) -C master/docs clean && rm -rf _trial_temp/; \
		;; \
	override_dh_auto_build) \
		echo "$(MAKE) -C master/docs html JOBS=$(NUMJOBS)"; \
		$(MAKE) -C master/docs html JOBS=$(NUMJOBS); \
		;; \
	esac

test_env = \
	PYTHONPATH=pkg:{destdir}/{install_dir} \
	PATH=$$PATH:{destdir}/usr/bin
test_command = trial3 --reporter=text buildbot.test buildbot_worker.test

debian/tmp/manpages/%: debian/manpages/%.scdoc
	mkdir -p $(@D)
	scdoc < $< > $@

manpages_src = $(wildcard debian/manpages/*.scdoc)
manpages = $(addprefix debian/tmp/manpages/,$(notdir $(manpages_src:.scdoc=)))

override_dh_auto_install: $(manpages)
	dh_auto_install --buildsystem=pybuild --sourcedirectory=master \
		--package=buildbot
	dh_auto_install --buildsystem=pybuild --sourcedirectory=worker \
		--package=buildbot-worker
	dh_auto_install --sourcedirectory=master/docs \
		--package=buildbot-doc --destdir=debian/buildbot-doc
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test --buildsystem=pybuild -- --system=custom \
		--test-args='$(test_env) $(test_command)'
endif

override_dh_auto_test:
	:

override_dh_installinit:
	dh_installinit --no-scripts

override_dh_installsystemd:
	dh_installsystemd --no-enable --no-start -r --no-restart-after-upgrade
	set -e; if test -d debian/buildbot/lib/systemd/system; then \
		ln -s /dev/null debian/buildbot/lib/systemd/system/buildbot.service; \
		ln -s /dev/null debian/buildbot-worker/lib/systemd/system/buildbot-worker.service; \
	else \
		ln -s /dev/null debian/buildbot/usr/lib/systemd/system/buildbot.service; \
		ln -s /dev/null debian/buildbot-worker/usr/lib/systemd/system/buildbot-worker.service; \
	fi

%:
	dh $@ --with python3,bash-completion,sphinxdoc

=== debian/watch ===
version=4
opts="pgpsigurlmangle=s%$%.asc%" \
https://github.com/buildbot/buildbot/releases \
	.+/buildbot-v?(\d\S+?)\.gitarchive\.tar\.gz debian uupdate
